using System;
using System.Windows.Forms;
using Mintfix.Client.UI;

namespace Mintfix.Client
{
	/// <summary>
	/// Summary description for GSClientApplicationContext.
	/// </summary>
	public class ClientApplicationContext : ApplicationContext
	{
		private readonly string _Login = string.Empty;
		private readonly string _Password = string.Empty;


		public ClientApplicationContext(string login, string password)
		{
			//
			// TODO: Add constructor logic here
			//
			_Login = login;
			_Password = password;
		}

		public bool ShowForm()
		{
		    string url = SettingsManager.GetServiceUrl();
            if (String.IsNullOrEmpty(url))
            {
                using (Settings frm = new Settings())
                {
                    if (frm.ShowDialog() != DialogResult.Yes)
                    {
                        return false;
                    }
                }
            }

		    this.MainForm = new MainForm(_Login, _Password);
		    return true;
		}

		protected override void ExitThreadCore()
		{
            if (this.MainForm != null)
			{
                this.MainForm.Close();
                this.MainForm.Dispose();
			}
			base.ExitThreadCore ();
		}
	}
}
