using System;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

namespace Mintfix.Client.DataGridExtensions
{
    /// <summary>
    /// Summary description for DataGridButtonColumn.
    /// </summary>
    public class DataGridButtonColumn : DataGridTextBoxColumn
    {         
        #region DataGridButtonColumn fields
        // add private fields here

		public delegate void GetColRowNum(int col, int row);

		public event GetColRowNum PushButton;

		protected DataGrid DataGrid;
		//public  GetColRowNum Dtg;
		private readonly Bitmap _ButtonFace;
		//private Bitmap _buttonFacePressed;
		private readonly int _ColumnNum;
		private int _PressedRow  = -1;
        #endregion
        

        #region DataGridButtonColumn  properties
        // add properties here
        #endregion
        

        #region DataGridButtonColumn constructors
        /// <summary>
        /// Constructor.
        /// </summary>
        /// <remarks>
        /// </remarks>
        public DataGridButtonColumn(int col, DataGrid grid)
        {
            //
            // TODO: Add constructor logic here
            //
			try
			{
				_ButtonFace = new Bitmap( Assembly.GetExecutingAssembly().GetManifestResourceStream("GS.Client.Resources.bullet_go.png") );
				_ColumnNum = col;
				DataGrid = grid;
				grid.MouseDown+=GridMouseDown;
				grid.MouseUp+=GridMouseUp;
			}
			catch (Exception)
			{
					
			}

 
        } 
        #endregion
        
        #region DataGridButtonColumn  public members
        
        // add public members (properties/methods) here
		private void GridMouseDown(object sender, MouseEventArgs e)
		{
			// 
			DataGrid dg = this.DataGridTableStyle.DataGrid;
			// 
			DataGrid.HitTestInfo hit = dg.HitTest( e.X, e.Y);
			//        
			bool isClickInCell = (hit.Column == this._ColumnNum && hit.Row > -1);
			Rectangle rect = new Rectangle(0, 0, 0, 0);

			if( isClickInCell)
			{
				
					_PressedRow = hit.Row;

				
			}
			this.Invalidate();
		}

		private void GridMouseUp(object sender, MouseEventArgs e)
		{

			DataGrid dg = this.DataGridTableStyle.DataGrid;
			DataGrid.HitTestInfo hit = dg.HitTest( e.X, e.Y);
			bool isClickInCell = (hit.Column == this._ColumnNum && hit.Row > -1);
			Rectangle rect = new Rectangle(0, 0, 0, 0);
		

			if( isClickInCell)
			{
					if(_PressedRow != -1 && PushButton != null )
						PushButton(_ColumnNum, _PressedRow);
			}
				_PressedRow = -1;
			
			this.Invalidate();
		}

        
        #endregion
        
        #region DataGridButtonColumn  private members

		protected override void Paint(Graphics g, Rectangle bounds, CurrencyManager source, int rowNum)
		{
		    if (source != null)
		        if (g != null) Paint(g, bounds, source, rowNum, true);
		}


        // add private members (properties/methods) here
		protected override void Paint(Graphics g, Rectangle bounds, CurrencyManager source, int rowNum, Brush backBrush, Brush foreBrush, bool alignToRight)
		{
			Paint(g, bounds, source, rowNum, alignToRight);
		}


		protected override void Paint(Graphics g, Rectangle bounds, CurrencyManager source, int rowNum, bool alignToRight)
		{
			if (_PressedRow == rowNum)
			{	
				ControlPaint.DrawButton(g, bounds, ButtonState.Pushed);
				g.DrawImageUnscaled(_ButtonFace, new Point(bounds.Left, bounds.Top));
			}
			else
			{
				ControlPaint.DrawButton(g, bounds, ButtonState.Normal);
				g.DrawImageUnscaled(_ButtonFace, new Point(bounds.Left, bounds.Top - 1));
			}
		}

		protected override void Edit(CurrencyManager source, int rowNum, Rectangle bounds, bool readOnly, string instantText, bool cellIsVisible)
		{
		}


        
		#endregion

	}
}
