using System.Drawing;
using System.Windows.Forms;

namespace Mintfix.Client.DataGridExtensions
{
    public delegate void DataGridColorEventHandler(
  object sender,
  DataGridColorlEventArgs e);


    class DataGridColorColumn : DataGridTextBoxColumn
    {
        public DataGridColorColumn()
        {
            
        }

        protected override void Paint(
        Graphics g, 
        Rectangle bounds, 
        CurrencyManager source, 
        int rowNum, 
        Brush backBrush, 
        Brush foreBrush, 
        bool alignToRight)
        {
            try
            {
              int col = DataGridTableStyle.GridColumnStyles.IndexOf(this);
              DataGridColorlEventArgs e = 
                new DataGridColorlEventArgs(col, rowNum,
                GetColumnValueAtRow(source, rowNum));
              OnCellPaint(e);

              if (e.BackBrush != null)
                backBrush = e.BackBrush;
              if (e.ForeBrush != null)
                foreBrush = e.ForeBrush;
            }
            finally
            {
              base.Paint (g, bounds, source, rowNum, backBrush, 
                foreBrush, alignToRight);
            }
         }

      /// <summary>
      /// ,    
      ///        
      /// </summary>
      public event DataGridColorEventHandler CellPaint;
      /// <summary>
      ///   SetCellFormat
      /// </summary>
      /// <param name="e"></param>
      protected virtual void OnCellPaint(
        DataGridColorlEventArgs e)
        { 
        if (CellPaint != null)
          CellPaint(this, e);
        }

    }
}
