using System;
using System.ComponentModel;
using System.Configuration;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Security.Cryptography;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using Microsoft.Win32;
using Mintfix.Client.NotificationService;
using Mintfix.Client.Properties;

namespace Mintfix.Client
{
    public sealed class Helper
	{

        [DllImport("winmm.dll", SetLastError = true)]
        public static extern bool PlaySound(string pszSound,
            UIntPtr hmod, uint fdwSound);

		[DllImport("user32.dll")]
		public static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);
	
		public static void PlaySoundFile(string path)
		{
			if((path.Length > 0) && (File.Exists(path)))
			{
				PlaySound(path, UIntPtr.Zero, 0);
			}

		}

        public static string GetDescription( DataType enumObj)
        {
            switch (enumObj)
            { 
                case DataType.Appointment:
                    return Resources.Appointment;
                case DataType.Task:
                    return Resources.Task;
                case DataType.Notification:
                    return Resources.Notification;
                default:
                    return Resources.Notification;
            }

        }


        public static string GetDescription(Enum enumObj)
        {
            FieldInfo fieldInfo = enumObj.GetType().GetField(enumObj.ToString());
            object[] attribArray = fieldInfo.GetCustomAttributes(false);
            var descrAttr = (DescriptionAttribute)attribArray[0];
            return descrAttr.Description;

        }

        public static string GetLocalizableDescription(Enum enumObj)
        {
            FieldInfo fieldInfo = enumObj.GetType().GetField(enumObj.ToString());
            object[] attribArray = fieldInfo.GetCustomAttributes(false);
            var descrAttr = (DescriptionAttribute)attribArray[0];
            return Resources.ResourceManager.GetString(descrAttr.Description);

        }

        #region config

        #endregion
	}
}
