﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Windows.Forms;
using System.IO;
using System.Text;
using Mintfix.Client.Properties;

namespace Mintfix.Client.Install
{
    [RunInstaller(true)]
    public partial class InstallAction : Installer
    {
        public const string ConfigName = "GS.Client.exe.config";
        public InstallAction()
        {
            InitializeComponent();
        }

        protected override void OnAfterInstall(IDictionary savedState)
        {
            string installPath = this.Context.Parameters["Path"];
            if (String.IsNullOrEmpty(installPath))
            {
                MessageBox.Show(Resources.InstalDirectoryNotFound);
                Rollback(savedState);
                return;
            }

            string server = this.Context.Parameters["Server"];
            if (String.IsNullOrEmpty(installPath))
            {
                MessageBox.Show(Resources.ServerNameNotFound);
            }
            else
            {
                string configPath = Path.Combine(installPath, ConfigName);
                if (File.Exists(configPath))
                {
                    string allconfig = File.ReadAllText(configPath);
                    StringBuilder sb = new StringBuilder(allconfig);
                    StringBuilder sbResult = sb.Replace("localhost", server);

                    File.WriteAllText(configPath, sbResult.ToString());
                }
                else
                {
                    MessageBox.Show(Resources.ConfigNotFound);
                    Rollback(savedState);
                }
            }
        }
    }
}
