using System;
using System.Globalization;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace Mintfix.Client
{
    class Program
    {
		[ DllImport( "kernel32.dll" ) ]
		public static extern bool SetProcessWorkingSetSize ( IntPtr handle, int minimumWorkingSetSize, int maximumWorkingSetSize );
        
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            var context = new ClientApplicationContext("", "");
            if(!context.ShowForm())
            {
                Application.Exit();
                return;
            }
                    
            SetProcessWorkingSetSize(System.Diagnostics.Process.GetCurrentProcess().Handle, -1, -1);

            Application.EnableVisualStyles();
            Application.ThreadException += ApplicationThreadException;
            Application.Run(context);
        }

		private static void ApplicationThreadException(object sender, ThreadExceptionEventArgs e)
		{
            Logger.WriteLog("Unhandled", e.Exception.Message);
			MessageBox.Show(e.Exception.Message);
		}
	}
}