using System;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Windows.Forms;
using Mintfix.Client.NotificationService;
using Mintfix.Client.Properties;
using Mintfix.Client.Tasks;
using Mintfix.Client.UI.Popup;

namespace Mintfix.Client.UI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : Form
	{
		
        private ContextMenu contextMenu1;
		private NotifyIcon notifyIcon1;
		private MenuItem miStopAlerting;
		private MenuItem miCheckForNewAlerts;
		private MenuItem miShowUnreadAlerts;
		private MenuItem miShowSettings;
        private IContainer components;
		private TrayPopup popUpWindow;
		private System.Windows.Forms.StatusBarPanel statusPanelDate;
		private System.Windows.Forms.StatusBarPanel statusPanelMessageCount;
		private System.Windows.Forms.StatusBar statusBarMain;

		//--------settings------------------
		public readonly string Login = "";
		public readonly string Pwd = "";
		public int Period = 15;
      
		private string SoundPath = "";
		private TaskThreadManager TaskManager = null;
	    private Icon ActiveIcon;
		private Icon PassiveIcon;
        private StringCollection MessageHyperLinks = new StringCollection();
        private DataGridView dgMessages;


        private bool ForceCloseApplication = false;
        private LinkLabel lnkClear;
        private Label label1;
        private Label label2;
        private Label label3;
        private Label lblDate;
        private Label lblOwner;
        private Label lblSubject;
        private PictureBox pictIcon;
        private DataGridViewTextBoxColumn type;
        private DataGridViewTextBoxColumn clmDate;
        private DataGridViewTextBoxColumn Owner;
        private DataGridViewLinkColumn clmSubject;

        
        private DataTable _SourceTable;
		
        
        
        public MainForm(string login, string pwd)
        {
            
			InitializeComponent();

			InitFormSettings();

			popUpWindow = new TrayPopup();
			popUpWindow.Width = Convert.ToInt32( 350 );
			popUpWindow.Height = Convert.ToInt32( 150 );
			popUpWindow.Opacity = Convert.ToInt32( 90);
			popUpWindow.TimeToLive = Convert.ToInt32( 15 );
            popUpWindow.TopColor = Color.FromArgb(187, 208, 238);
            popUpWindow.BottomColor = Color.FromArgb(187, 208, 238);
            popUpWindow.Color = Color.FromArgb(35, 81, 141);
            popUpWindow.Font = new Font(FontFamily.GenericSansSerif, 8, FontStyle.Bold);
            
            //popUpWindow.font.Style = FontStyle.Bold;
            
			popUpWindow.Click+=new EventHandler(ShowUnreadAlerts);
			
			Hide();
			
            //  
            TaskManager = new TaskThreadManager(this);
            TaskManager.Run();

        }

		
		
		#region Form Level Events

		
		private void MainForm_Load(object sender, System.EventArgs e)
		{
            this.ShowInTaskbar = false;
            Helper.ShowWindow(this.Handle, (int)WindowShowStyle.Hide);
		}
       
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }

                TaskManager = null;
                //EventManager = null;
                popUpWindow.Dispose();
            }

            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            System.Windows.Forms.DataGridViewCellStyle dataGridViewCellStyle3 = new System.Windows.Forms.DataGridViewCellStyle();
            System.Windows.Forms.DataGridViewCellStyle dataGridViewCellStyle1 = new System.Windows.Forms.DataGridViewCellStyle();
            System.Windows.Forms.DataGridViewCellStyle dataGridViewCellStyle2 = new System.Windows.Forms.DataGridViewCellStyle();
            this.contextMenu1 = new System.Windows.Forms.ContextMenu();
            this.miStopAlerting = new System.Windows.Forms.MenuItem();
            this.miShowSettings = new System.Windows.Forms.MenuItem();
            this.miShowUnreadAlerts = new System.Windows.Forms.MenuItem();
            this.miCheckForNewAlerts = new System.Windows.Forms.MenuItem();
            this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
            this.statusBarMain = new System.Windows.Forms.StatusBar();
            this.statusPanelDate = new System.Windows.Forms.StatusBarPanel();
            this.statusPanelMessageCount = new System.Windows.Forms.StatusBarPanel();
            this.dgMessages = new System.Windows.Forms.DataGridView();
            this.type = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.clmDate = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.Owner = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.clmSubject = new System.Windows.Forms.DataGridViewLinkColumn();
            this.lnkClear = new System.Windows.Forms.LinkLabel();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.lblDate = new System.Windows.Forms.Label();
            this.lblOwner = new System.Windows.Forms.Label();
            this.lblSubject = new System.Windows.Forms.Label();
            this.pictIcon = new System.Windows.Forms.PictureBox();
            ((System.ComponentModel.ISupportInitialize)(this.statusPanelDate)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusPanelMessageCount)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.dgMessages)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictIcon)).BeginInit();
            this.SuspendLayout();
            // 
            // contextMenu1
            // 
            this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miStopAlerting,
            this.miShowSettings,
            this.miShowUnreadAlerts,
            this.miCheckForNewAlerts});
            resources.ApplyResources(this.contextMenu1, "contextMenu1");
            // 
            // miStopAlerting
            // 
            resources.ApplyResources(this.miStopAlerting, "miStopAlerting");
            this.miStopAlerting.Index = 0;
            this.miStopAlerting.Click += new System.EventHandler(this.StopAlerting);
            // 
            // miShowSettings
            // 
            resources.ApplyResources(this.miShowSettings, "miShowSettings");
            this.miShowSettings.Index = 1;
            this.miShowSettings.Click += new System.EventHandler(this.ShowSettings);
            // 
            // miShowUnreadAlerts
            // 
            resources.ApplyResources(this.miShowUnreadAlerts, "miShowUnreadAlerts");
            this.miShowUnreadAlerts.Index = 2;
            this.miShowUnreadAlerts.Click += new System.EventHandler(this.ShowUnreadAlerts);
            // 
            // miCheckForNewAlerts
            // 
            resources.ApplyResources(this.miCheckForNewAlerts, "miCheckForNewAlerts");
            this.miCheckForNewAlerts.Index = 3;
            this.miCheckForNewAlerts.Click += new System.EventHandler(this.CheckForNewAlerts);
            // 
            // notifyIcon1
            // 
            resources.ApplyResources(this.notifyIcon1, "notifyIcon1");
            this.notifyIcon1.ContextMenu = this.contextMenu1;
            this.notifyIcon1.Icon = global::Mintfix.Client.Properties.Resources.chat;
            this.notifyIcon1.DoubleClick += new System.EventHandler(this.notifyIcon1_DoubleClick);
            // 
            // statusBarMain
            // 
            resources.ApplyResources(this.statusBarMain, "statusBarMain");
            this.statusBarMain.Name = "statusBarMain";
            this.statusBarMain.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
            this.statusPanelDate,
            this.statusPanelMessageCount});
            this.statusBarMain.ShowPanels = true;
            // 
            // statusPanelDate
            // 
            resources.ApplyResources(this.statusPanelDate, "statusPanelDate");
            // 
            // statusPanelMessageCount
            // 
            resources.ApplyResources(this.statusPanelMessageCount, "statusPanelMessageCount");
            // 
            // dgMessages
            // 
            resources.ApplyResources(this.dgMessages, "dgMessages");
            this.dgMessages.AllowUserToAddRows = false;
            this.dgMessages.AllowUserToDeleteRows = false;
            this.dgMessages.AllowUserToOrderColumns = true;
            this.dgMessages.BackgroundColor = System.Drawing.Color.White;
            this.dgMessages.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.dgMessages.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
            this.dgMessages.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
            this.type,
            this.clmDate,
            this.Owner,
            this.clmSubject});
            this.dgMessages.MultiSelect = false;
            this.dgMessages.Name = "dgMessages";
            this.dgMessages.ReadOnly = true;
            dataGridViewCellStyle3.Alignment = System.Windows.Forms.DataGridViewContentAlignment.MiddleLeft;
            dataGridViewCellStyle3.BackColor = System.Drawing.SystemColors.Control;
            dataGridViewCellStyle3.Font = new System.Drawing.Font("Arial", 8.25F);
            dataGridViewCellStyle3.ForeColor = System.Drawing.SystemColors.WindowText;
            dataGridViewCellStyle3.SelectionBackColor = System.Drawing.Color.LightBlue;
            dataGridViewCellStyle3.SelectionForeColor = System.Drawing.SystemColors.WindowText;
            dataGridViewCellStyle3.WrapMode = System.Windows.Forms.DataGridViewTriState.True;
            this.dgMessages.RowHeadersDefaultCellStyle = dataGridViewCellStyle3;
            this.dgMessages.RowHeadersVisible = false;
            this.dgMessages.SelectionMode = System.Windows.Forms.DataGridViewSelectionMode.FullRowSelect;
            this.dgMessages.StandardTab = true;
            this.dgMessages.CellClick += new System.Windows.Forms.DataGridViewCellEventHandler(this.dgMessages_CellClick);
            this.dgMessages.CellContentClick += new System.Windows.Forms.DataGridViewCellEventHandler(this.dgMessages_CellContentClick);
            // 
            // type
            // 
            this.type.DataPropertyName = "type";
            resources.ApplyResources(this.type, "type");
            this.type.Name = "type";
            this.type.ReadOnly = true;
            // 
            // clmDate
            // 
            this.clmDate.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.None;
            this.clmDate.DataPropertyName = "date";
            dataGridViewCellStyle1.ForeColor = System.Drawing.SystemColors.WindowText;
            dataGridViewCellStyle1.SelectionBackColor = System.Drawing.Color.AliceBlue;
            dataGridViewCellStyle1.SelectionForeColor = System.Drawing.SystemColors.WindowText;
            this.clmDate.DefaultCellStyle = dataGridViewCellStyle1;
            resources.ApplyResources(this.clmDate, "clmDate");
            this.clmDate.Name = "clmDate";
            this.clmDate.ReadOnly = true;
            // 
            // Owner
            // 
            this.Owner.DataPropertyName = "Owner";
            resources.ApplyResources(this.Owner, "Owner");
            this.Owner.Name = "Owner";
            this.Owner.ReadOnly = true;
            // 
            // clmSubject
            // 
            this.clmSubject.DataPropertyName = "description";
            dataGridViewCellStyle2.ForeColor = System.Drawing.SystemColors.WindowText;
            dataGridViewCellStyle2.SelectionBackColor = System.Drawing.Color.AliceBlue;
            dataGridViewCellStyle2.SelectionForeColor = System.Drawing.SystemColors.WindowText;
            this.clmSubject.DefaultCellStyle = dataGridViewCellStyle2;
            resources.ApplyResources(this.clmSubject, "clmSubject");
            this.clmSubject.Name = "clmSubject";
            this.clmSubject.ReadOnly = true;
            // 
            // lnkClear
            // 
            resources.ApplyResources(this.lnkClear, "lnkClear");
            this.lnkClear.Name = "lnkClear";
            this.lnkClear.TabStop = true;
            this.lnkClear.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.lnkClear_LinkClicked);
            // 
            // label1
            // 
            resources.ApplyResources(this.label1, "label1");
            this.label1.Name = "label1";
            // 
            // label2
            // 
            resources.ApplyResources(this.label2, "label2");
            this.label2.Name = "label2";
            // 
            // label3
            // 
            resources.ApplyResources(this.label3, "label3");
            this.label3.Name = "label3";
            // 
            // lblDate
            // 
            resources.ApplyResources(this.lblDate, "lblDate");
            this.lblDate.Name = "lblDate";
            // 
            // lblOwner
            // 
            resources.ApplyResources(this.lblOwner, "lblOwner");
            this.lblOwner.Name = "lblOwner";
            // 
            // lblSubject
            // 
            resources.ApplyResources(this.lblSubject, "lblSubject");
            this.lblSubject.Name = "lblSubject";
            // 
            // pictIcon
            // 
            resources.ApplyResources(this.pictIcon, "pictIcon");
            this.pictIcon.Name = "pictIcon";
            this.pictIcon.TabStop = false;
            // 
            // MainForm
            // 
            resources.ApplyResources(this, "$this");
            this.BackColor = System.Drawing.SystemColors.ControlLight;
            this.Controls.Add(this.pictIcon);
            this.Controls.Add(this.lblSubject);
            this.Controls.Add(this.lblOwner);
            this.Controls.Add(this.lblDate);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.lnkClear);
            this.Controls.Add(this.dgMessages);
            this.Controls.Add(this.statusBarMain);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "MainForm";
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
            this.Load += new System.EventHandler(this.MainForm_Load);
            ((System.ComponentModel.ISupportInitialize)(this.statusPanelDate)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusPanelMessageCount)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.dgMessages)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictIcon)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        private void InitFormSettings()
        {
            Assembly currentAssembly = Assembly.GetExecutingAssembly();

            foreach (string s in currentAssembly.GetManifestResourceNames())
                Debug.WriteLine(s);

            #region icons load

            ActiveIcon = Resources.chat; //new Icon(currentAssembly.GetManifestResourceStream( "GS.Client.Resources.Alert.ico"));
            PassiveIcon = Properties.Resources.pause;// new Icon(currentAssembly.GetManifestResourceStream("GS.Client.Resources.AlertStopped.ico"));
            #endregion

            #region sound file load
            if (File.Exists(Environment.GetEnvironmentVariable("windir") + @"\Media\notify.wav"))
            {
                SoundPath = Environment.GetEnvironmentVariable("windir") + @"\Media\notify.wav";
            }
            else if (File.Exists("ringin.wav"))
            {
                SoundPath = "ringin.wav";
            }

            #endregion

            #region source table design
            _SourceTable = new DataTable("Messages");

            DataColumn dataColumn00 = new DataColumn();
            dataColumn00.DataType = Type.GetType("System.String");
            dataColumn00.ColumnName = "type";
            dataColumn00.AutoIncrement = false;
            dataColumn00.Caption = "";
            dataColumn00.ReadOnly = false;
            dataColumn00.Unique = false;
            _SourceTable.Columns.Add(dataColumn00);

            DataColumn dataColumn0 = new DataColumn();
            dataColumn0.DataType = Type.GetType("System.String");
            dataColumn0.ColumnName = "date";
            dataColumn0.AutoIncrement = false;
            dataColumn0.Caption = " ";
            dataColumn0.ReadOnly = false;
            dataColumn0.Unique = false;
            _SourceTable.Columns.Add(dataColumn0);


            DataColumn dataColumn1 = new DataColumn();
            dataColumn1.DataType = Type.GetType("System.String");
            dataColumn1.ColumnName = "owner";
            dataColumn1.AutoIncrement = false;
            dataColumn1.Caption = "";
            dataColumn1.ReadOnly = false;
            dataColumn1.Unique = false;
            _SourceTable.Columns.Add(dataColumn1);

            DataColumn dataColumn2 = new DataColumn();
            dataColumn2.DataType = Type.GetType("System.String");
            dataColumn2.ColumnName = "description";
            dataColumn2.AutoIncrement = false;
            dataColumn2.Caption = "";
            dataColumn2.ReadOnly = false;
            dataColumn2.Unique = false;
            _SourceTable.Columns.Add(dataColumn2);

            DataColumn dataColumn3 = new DataColumn();
            dataColumn3.DataType = Type.GetType("System.String");
            dataColumn3.ColumnName = "href";
            dataColumn3.AutoIncrement = false;
            dataColumn3.Caption = "";
            dataColumn3.ReadOnly = false;
            dataColumn3.Unique = false;
            _SourceTable.Columns.Add(dataColumn3);
            #endregion


        }

		#endregion
        
		#region menu actions

		private void StopAlerting(object sender, EventArgs e)
		{
		    ForceCloseApplication = true;
			Close();
			Application.Exit();
		}

		private void CheckForNewAlerts(object sender, EventArgs e)
		{
			TaskManager.CheckNow();
		}

		private void ShowUnreadAlerts(object sender, EventArgs e)
		{
            this.Show();
            this.Activate();
		}


		private void ShowSettings(object sender, EventArgs e)
		{
			miShowSettings.Enabled = false;
			Settings settings = new Settings( );
			settings.Closed+=new EventHandler(settings_Closed);
            settings.Show();
		}
		
        #endregion 

	
        public void BindGrid(DataTransferObject[] messages)
		{
            if (messages != null && messages.Length > 0)
			{
							
                foreach (DataTransferObject dto in messages)
				{

                        DataRow row = _SourceTable.NewRow();
						row["owner"] = dto.OwnerName;
						row["description"] = dto.Subject;
                        row["type"] = Helper.GetDescription(dto.Type);
						row["href"] = "";
						row["date"] = dto.PublishDate.ToString("dd.MM HH:mm");
						_SourceTable.Rows.InsertAt(row,0);
                        if (!String.IsNullOrEmpty(dto.Href))
                        {
                            MessageHyperLinks.Insert(0, dto.Href);
                        }
                        else
                        {
                            MessageHyperLinks.Insert(0, String.Empty);
                        }
				}

                dgMessages.DataSource = _SourceTable;
			}
		}
		
		private void col_PushButton(int col, int row)
		{
            if(row == -1)
            {
                return;
            }

            string url = MessageHyperLinks[row];
            if (!String.IsNullOrEmpty(url))
            {
                Process.Start(MessageHyperLinks[row]);
            }
		}
		
		public void ShowForm( DataTransferObject[] list )
		{
			if( this.InvokeRequired )
			{
				Invoke(new ShowMessagesListDelegate(ShowForm), new object[]{list});
			}
			else
			{
                try
                {
                    notifyIcon1.Icon = ActiveIcon;
                    statusBarMain.Panels[0].Text = Resources.TimeLabel + DateTime.Now.ToShortTimeString();

                    if ((list != null) && (list.Length > 0))
                    {
                        BindGrid(list);

                        statusBarMain.Panels[1].Text = Resources.TotalMessageCountLabel + _SourceTable.Rows.Count;

                        int newMessagesCount = list.Length;
                  
                        if (newMessagesCount > 0)
                        {

                            string message = string.Empty;
                            if (newMessagesCount == 1)
                            {
                                string url = String.Empty;
                                if (!String.IsNullOrEmpty(list[0].Href))
                                {
                                    url = list[0].Href;
                                }

                                string popupMessage = list[0].PublishDate.ToShortTimeString() + " - " + list[0].Subject;

                                popUpWindow.ShowWindow(popupMessage, "", url);
                            }
                            else
                            {
                                this.TopMost = true;
                                this.ShowInTaskbar = true;
                                this.Show();
                                this.Activate();
                                Invalidate();
                            }
                            Helper.PlaySoundFile(SoundPath);
                        }
                        else
                        {
                            //MessageGrid.DataSource = null;
                            statusBarMain.Panels[1].Text = Resources.NoMessageLabel;
                        }
                    }
                }
                catch (Exception xE)
                {
                    MessageBox.Show(xE.Message);
                }
			}
		}
		
		public void ShowConnectionState(AuthResult state, string msg)
		{
			if( InvokeRequired )
			{
				Invoke(new SetConnectionStateDelegate(ShowConnectionState), new object[]{state, msg});
			}
			else
			{
                string lastStateText = notifyIcon1.Text;
                notifyIcon1.Icon = AuthResult.NoError == state ? ActiveIcon : PassiveIcon;
                notifyIcon1.Text = Helper.GetLocalizableDescription(state);
                if (state != AuthResult.NoError && lastStateText != notifyIcon1.Text)
				{
                    MessageBox.Show(Helper.GetLocalizableDescription(state) + " : " + msg, Resources.ConnectionError, MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}

		}		
	

		#region Component events

	

		private void notifyIcon1_DoubleClick(object sender, EventArgs e)
		{
            this.Show();
            this.Activate();
		}
        
	
		
		private void settings_Closed(object sender, EventArgs e)
		{
			miShowSettings.Enabled = true;
         
		}
		#endregion


        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            //    (ForceCloseApplication)
            //  ,     
            if (ForceCloseApplication || (e.CloseReason != CloseReason.UserClosing && e.CloseReason != CloseReason.None))
            {
                try
                {
                    //   
                    if (TaskManager != null)
                        TaskManager.EndTask();
                }
                catch (Exception xE)
                {
                    MessageBox.Show(xE.Message);
                }
                return;
            }

            //    -   
            //    
            e.Cancel = true;
            Hide();
        }


        private void ClearFormData()
        {
            MessageHyperLinks.Clear();
            _SourceTable.Clear();

            lblDate.Text = String.Empty;
            lblOwner.Text = String.Empty;
            lblSubject.Text = String.Empty;

            statusBarMain.Panels[1].Text = String.Empty;
        }

        private void dgMessages_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == 3)
                col_PushButton(e.ColumnIndex, e.RowIndex);
        }

        private void lnkClear_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ClearFormData();
            dgMessages.DataSource = _SourceTable;
            
        }

        private void dgMessages_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (_SourceTable.Rows.Count>0 && _SourceTable.Rows.Count > e.RowIndex)
            {
                DataRow row = _SourceTable.Rows[e.RowIndex];

                lblDate.Text = row["date"].ToString();
                lblOwner.Text = row["owner"].ToString();
                lblSubject.Text = row["description"].ToString();
            }
        }


	}
}