using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing;

namespace Mintfix.Client.UI.Popup
{
	/// <summary>
	/// Summary description for PopUpWnd.
	/// </summary>
	/// 
	[ToolboxBitmap(typeof(NotifyIcon))]
	public class TrayPopup : System.ComponentModel.Component
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TrayPopup(System.ComponentModel.IContainer container)
		{
		    container.Add(this);
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public TrayPopup()
		{
		    InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		MessageForm _Dlg;

		public void ShowWindow(string messageToShow, string messageTitle, string link)
		{
			_Dlg = new MessageForm
			          {
			              link = link,
			              ParentControl = this,
			              icon = this.Icon,
			              text = messageToShow,
			              title = messageTitle,
			              font = this.Font,
			              color = this.Color,
			              Width = this.Width,
			              Height = this.Height,
			              timer1 = {Interval = TimeToLive*1000}
			          };
		    _Dlg.SetDesktopLocation(Screen.PrimaryScreen.WorkingArea.Width-_Dlg.Width, Screen.PrimaryScreen.WorkingArea.Height-_Dlg.Height);
			_Dlg.Opacity = (double)this.Opacity/100.0;
            _Dlg.TopLevel = true;
            _Dlg.TopMost = true;
			_Dlg.Show();
			//Helper.ShowWindow(dlg.Handle, (int)WindowShowStyle.ShowNoActivate);
			_Dlg.Visible = true;
		

		}

		private int _FWidth = 100;
		[Description("Window Width."),DefaultValue((int)100),Category("Appearance")]
		public int Width
		{
			get
			{
				return _FWidth;
			}
			set
			{
				_FWidth = value;
			}
		}

		private int _FHeight = 100;

		[Description("Window Height."),DefaultValue((int)100),Category("Appearance")]
		public int Height
		{
			get
			{
				return _FHeight;
			}
			set
			{
				_FHeight = value;
			}
		}

		private Font _Ffont = new Font(FontFamily.GenericSansSerif,(float)8.25);
		[Description("Text Font."),Category("Appearance")]
		public Font Font
		{
			get
			{
				return _Ffont;
			}
			set
			{
				_Ffont = value;

			}
		}


		private Color _Fcolor = Color.White;
		[Description("Text Color."),Category("Appearance")]
		public Color Color
		{
			get
			{
			    return  _Fcolor;
			}
			set
			{
			    _Fcolor=value;
			}
		}

		private Color _FTopColor = Color.Blue;
		[Description("Top gradient Color."),Category("Appearance")]
		public Color TopColor
		{
			get
			{
				return  _FTopColor;
			}
			set
			{
				_FTopColor = value;
			}
		}

		private Color _FBottomColor = Color.Red;
		[Description("Bottom gradient Color."),Category("Appearance")]
		public Color BottomColor
		{
			get
			{
				return  _FBottomColor;
			}
			set
			{
				_FBottomColor = value;
			}
		}

	    private Icon _Ficon = Properties.Resources.Alarm;
		[Description("Icon for message."),Category("Appearance")]
		public Icon Icon
		{
			get
			{
				return  _Ficon;
			}
			set
			{
				_Ficon = value;
			}
		}
		

		private int _Fopacity = 100;
		[Description("Window Opacity."),Category("Appearance")]
		public int Opacity
		{
			get
			{
			    return  _Fopacity;
			}
			set
			{
				if((value>100)||(value<0)) _Fopacity = 100; 
				else _Fopacity=(int)value;
			}
		}

		private int _FTimeToLive = 10;
		[Description("Time To Live, seconds."),DefaultValue((int)5),Category("Appearance")]
		public int TimeToLive
		{
			get
			{
				return _FTimeToLive;
			}
			set
			{
				_FTimeToLive = value;
			}
		}

		public event EventHandler Click;

		internal virtual void OnClick(object sender, EventArgs e) 
		{
			if (Click != null) 
			{
				//Invokes the delegates.
				Click(this, e); 
			}
		}

		public void Hide()
		{
			_Dlg.Visible = false;
		}

	}
}
