//
// DTO( Data transfer objects ) declarations
//


using System;
using System.Xml.Serialization;

namespace Mintfix.Web.Interfaces
{
    [Serializable]
    [SoapInclude(typeof(DataType))]
    public class DataTransferObject
    {
        public DataType Type
        {
            get;
            set;
        }

        /// <summary>
        /// Row identifier
        /// </summary>
        public string Id 
        { 
            get; 
            set; 
        }
        
        /// <summary>
        /// Row title
        /// </summary>
        public string Subject 
        { 
            get; 
            set; 
        }

        /// <summary>
        /// Full row descripton
        /// </summary>
        public string Description 
        { 
            get; 
            set; 
        }
        
        /// <summary>
        /// user name
        /// </summary>
        public string OwnerName 
        { 
            get; set; 
        }
        
        /// <summary>
        /// Hyperlink for row
        /// </summary>
        public string Href 
        { 
            get; 
            set; 
        }
        
        public DateTime PublishDate 
        { 
            get; 
            set; 
        }

        public DataTransferObject()
        {
            Type = DataType.Notification;
        }

        public DataTransferObject(string id, string subject)
        {
            this.Id = id;
            this.Subject = subject;
            this.Type = DataType.Notification;
        }



    }
}
