﻿using System;
using System.Collections.Specialized;

namespace Mintfix.Web.Interfaces
{
    /// <summary>
    /// Factory
    /// </summary>
    public interface IDataTransferObjectFactory
    {
        /// <summary>
        /// Factory configuration
        /// </summary>
        /// <param name="configuration"></param>
        void Configure(NameValueCollection configuration);
        
        /// <summary>
        /// Return objects, created or modified specified date range
        /// </summary>
        /// <param name="userName">User name</param>
        /// <param name="dateStart">start date</param>
        /// <param name="dateEnd">end date</param>
        /// <returns></returns>
        DataTransferObject[] GetObjects(string userName, DateTime dateStart, DateTime dateEnd);
    }
}
