﻿using System;
using System.Collections.Generic;

namespace Mintfix.Web.Interfaces
{
    public class MockDataFactory  : IDataTransferObjectFactory
    {
        #region IDataTransferObjectFactory Members

        public DataTransferObject[] GetObjects(string username, DateTime dateStart, DateTime dateEnd)
        {
            var result = new List<DataTransferObject>();
            
            var obj = new DataTransferObject("123", "Urgent! Need help ");
            obj.Type = DataType.Task;
            obj.PublishDate = DateTime.Now;
            obj.OwnerName = username;
            obj.Href = "http://yahoo.com";
            obj.Description = "Long text.";

            result.Add(obj);

            if (DateTime.Now.Minute % 2 == 1)
            {
                var obj2 = new DataTransferObject("124", "Report in one hour");
                obj2.Type = DataType.Task;
                obj2.PublishDate = DateTime.Now;
                obj2.OwnerName = username;
                obj2.Href = "http://google.com";
                obj2.Description = "Long long description 2.";

                result.Add(obj2);
            }

            return result.ToArray();
        }


        public void Configure(System.Collections.Specialized.NameValueCollection configuration)
        {
            //There are no configuration needed
        }

        #endregion
    }
}
